ghc-7.0.4: The GHC API

TcGenDeriv

# Documentation

type DerivAuxBinds = [DerivAuxBind]Source

isDupAux :: DerivAuxBind -> DerivAuxBind -> Bool Source

gen_Bounded_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Enum_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Eq_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Ix_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Ord_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Read_binds :: FixityEnv -> SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Show_binds :: FixityEnv -> SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Data_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Typeable_binds :: SrcSpan -> TyCon -> LHsBinds RdrName Source

gen_Functor_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

data FFoldType a Source

Constructors

FT |

Fields

ft_triv :: a
ft_var :: a
ft_co_var :: a
ft_fun :: a -> a -> a
ft_tup :: Boxity -> [a] -> a
ft_ty_app :: Type -> a -> a
ft_bad_app :: a
ft_forall :: TcTyVar -> a -> a

functorLikeTraverseSource

Arguments

:: TyVar | Variable to look for
-> FFoldType a | How to fold
-> Type | Type to process
-> a |

deepSubtypesContaining :: TyVar -> Type -> [TcType]Source

foldDataConArgs :: FFoldType a -> DataCon -> [a]Source

gen_Foldable_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

gen_Traversable_binds :: SrcSpan -> TyCon -> (LHsBinds RdrName, DerivAuxBinds)Source

genAuxBind :: SrcSpan -> DerivAuxBind -> (LHsBind RdrName, LSig RdrName)Source